export * from './accountApi';
import { AccountApi } from './accountApi';
export * from './heatmapApi';
import { HeatmapApi } from './heatmapApi';
export * from './imageTargetApi';
import { ImageTargetApi } from './imageTargetApi';
export * from './imageTargetCollectionApi';
import { ImageTargetCollectionApi } from './imageTargetCollectionApi';
export * from './objectTargetApi';
import { ObjectTargetApi } from './objectTargetApi';
export * from './objectTargetCollectionApi';
import { ObjectTargetCollectionApi } from './objectTargetCollectionApi';
export * from './projectApi';
import { ProjectApi } from './projectApi';
import * as http from 'http';

export class HttpError extends Error {
    constructor (public response: http.IncomingMessage, public body: any, public statusCode?: number) {
        super('HTTP request failed');
        this.name = 'HttpError';
    }
}

export { RequestFile } from '../model/models';

export const APIS = [AccountApi, HeatmapApi, ImageTargetApi, ImageTargetCollectionApi, ObjectTargetApi, ObjectTargetCollectionApi, ProjectApi];
