/**
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import localVarRequest from 'request';
import http from 'http';

/* tslint:disable:no-unused-locals */
import { CreateImageTargetsBody } from '../model/createImageTargetsBody';
import { CreateImageTargetsResponse } from '../model/createImageTargetsResponse';
import { ImageTargetResponse } from '../model/imageTargetResponse';
import { UpdateImageTargetBody } from '../model/updateImageTargetBody';

import { ObjectSerializer, Authentication, VoidAuth, Interceptor } from '../model/models';

import { HttpError, RequestFile } from './apis';

let defaultBasePath = 'https://api-eu.wikitude.com/cloudrecognition';

// ===============================================
// This file is autogenerated - Please do not edit
// ===============================================

export enum ImageTargetApiApiKeys {
}

export class ImageTargetApi {
    protected _basePath = defaultBasePath;
    protected _defaultHeaders : any = {};
    protected _useQuerystring : boolean = false;

    protected authentications = {
        'default': <Authentication>new VoidAuth(),
    }

    protected interceptors: Interceptor[] = [];

    constructor(basePath?: string);
    constructor(basePathOrUsername: string, password?: string, basePath?: string) {
        if (password) {
            if (basePath) {
                this.basePath = basePath;
            }
        } else {
            if (basePathOrUsername) {
                this.basePath = basePathOrUsername
            }
        }
    }

    set useQuerystring(value: boolean) {
        this._useQuerystring = value;
    }

    set basePath(basePath: string) {
        this._basePath = basePath;
    }

    set defaultHeaders(defaultHeaders: any) {
        this._defaultHeaders = defaultHeaders;
    }

    get defaultHeaders() {
        return this._defaultHeaders;
    }

    get basePath() {
        return this._basePath;
    }

    public setDefaultAuthentication(auth: Authentication) {
        this.authentications.default = auth;
    }

    public setApiKey(key: ImageTargetApiApiKeys, value: string) {
        (this.authentications as any)[ImageTargetApiApiKeys[key]].apiKey = value;
    }

    public addInterceptor(interceptor: Interceptor) {
        this.interceptors.push(interceptor);
    }

    /**
     * Create a set of up to 10 new Targets in a Target Collection in your account. The task to create the listed Targets is scheduled. The response body contains the initial job status. \"Location\"-header is the url to the GET endpoint that returns current job status information. It is recommended to query this endpoint after \"estimatedLatency\" milliseconds, and poll it afterwards every 10 seconds in case job status is still not \"COMPLETED\". Once job status is \"COMPLETED\" each item holds a \"target\" attribute of the created target or an \"error\" attribute. 
     * @summary Create Image Targets
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param contentType The Content Type of the body. Must be set to application/json.
     * @param tcId Unique identifier of the Image Target Collection.
     * @param createImageTargetsBody 
     */
    public async createImageTargets (xVersion: string, xToken: string, contentType: string, tcId: string, createImageTargetsBody?: Array<CreateImageTargetsBody>, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body: CreateImageTargetsResponse;  }> {
        const localVarPath = this.basePath + '/targetCollection/{tcId}/targets'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        } else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling createImageTargets.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling createImageTargets.');
        }

        // verify required parameter 'contentType' is not null or undefined
        if (contentType === null || contentType === undefined) {
            throw new Error('Required parameter contentType was null or undefined when calling createImageTargets.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling createImageTargets.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        localVarHeaderParams['Content-Type'] = ObjectSerializer.serialize(contentType, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'POST',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
            body: ObjectSerializer.serialize(createImageTargetsBody, "Array<CreateImageTargetsBody>")
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body: CreateImageTargetsResponse;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        body = ObjectSerializer.deserialize(body, "CreateImageTargetsResponse");
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
    /**
     * Delete a particular Target from your account.
     * @summary Delete Image Target
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param tcId Unique identifier of the Image Target Collection.
     * @param targetId Unique identifier of the Image Target.
     */
    public async deleteImageTarget (xVersion: string, xToken: string, tcId: string, targetId: string, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body?: any;  }> {
        const localVarPath = this.basePath + '/targetCollection/{tcId}/target/{targetId}'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)))
            .replace('{' + 'targetId' + '}', encodeURIComponent(String(targetId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling deleteImageTarget.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling deleteImageTarget.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling deleteImageTarget.');
        }

        // verify required parameter 'targetId' is not null or undefined
        if (targetId === null || targetId === undefined) {
            throw new Error('Required parameter targetId was null or undefined when calling deleteImageTarget.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'DELETE',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body?: any;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
    /**
     * Request a particular Image Target in a particular Target Collection.
     * @summary Get Image Target
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param tcId Unique identifier of the Image Target Collection.
     * @param targetId Unique identifier of the Image Target.
     */
    public async getImageTarget (xVersion: string, xToken: string, tcId: string, targetId: string, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body: ImageTargetResponse;  }> {
        const localVarPath = this.basePath + '/targetCollection/{tcId}/target/{targetId}'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)))
            .replace('{' + 'targetId' + '}', encodeURIComponent(String(targetId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        } else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling getImageTarget.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling getImageTarget.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling getImageTarget.');
        }

        // verify required parameter 'targetId' is not null or undefined
        if (targetId === null || targetId === undefined) {
            throw new Error('Required parameter targetId was null or undefined when calling getImageTarget.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body: ImageTargetResponse;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        body = ObjectSerializer.deserialize(body, "ImageTargetResponse");
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
    /**
     * Retrieves information status about a particular scheduled targets creation.
     * @summary Status - Image Targets Creation
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param tcId Unique identifier of the Image Target Collection.
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint.
     */
    public async getImageTargetStatus (xVersion: string, xToken: string, tcId: string, generationId: string, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body: CreateImageTargetsResponse;  }> {
        const localVarPath = this.basePath + '/targetCollection/{tcId}/generation/targets/{generationId}'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)))
            .replace('{' + 'generationId' + '}', encodeURIComponent(String(generationId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        } else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling getImageTargetStatus.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling getImageTargetStatus.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling getImageTargetStatus.');
        }

        // verify required parameter 'generationId' is not null or undefined
        if (generationId === null || generationId === undefined) {
            throw new Error('Required parameter generationId was null or undefined when calling getImageTargetStatus.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body: CreateImageTargetsResponse;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        body = ObjectSerializer.deserialize(body, "CreateImageTargetsResponse");
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
    /**
     * Request all Image Targets in a Target Collection.
     * @summary Get Image Targets
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param tcId Unique identifier of the Image Target Collection.
     * @param sortby Targets may be sorted by \&#39;name\&#39;, \&#39;creDat\&#39;, \&#39;modDat\&#39;, \&#39;rating\&#39;. Default value: \&#39;creDat\&#39;
     * @param sortorder Targets may be sorted ascending (\&#39;asc\&#39;) or descending (\&#39;desc\&#39;). Default value: \&#39;desc\&#39;
     * @param skip Set 0 to start with first target, set e.g. to 2 to skip first 2 targets. Default value: 0
     * @param limit Set to 0 for \&#39;all targets\&#39; or use positive value to define max. amount of targets to return. Default value: 0
     * @param s The search string to look for in target names.
     * @param addHasAugmentations Add the hasAugmentations property.
     */
    public async getImageTargets (xVersion: string, xToken: string, tcId: string, sortby?: string, sortorder?: string, skip?: number, limit?: number, s?: string, addHasAugmentations?: boolean, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body: Array<ImageTargetResponse>;  }> {
        const localVarPath = this.basePath + '/targetCollection/{tcId}/target'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        } else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling getImageTargets.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling getImageTargets.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling getImageTargets.');
        }

        if (sortby !== undefined) {
            localVarQueryParameters['sortby'] = ObjectSerializer.serialize(sortby, "string");
        }

        if (sortorder !== undefined) {
            localVarQueryParameters['sortorder'] = ObjectSerializer.serialize(sortorder, "string");
        }

        if (skip !== undefined) {
            localVarQueryParameters['skip'] = ObjectSerializer.serialize(skip, "number");
        }

        if (limit !== undefined) {
            localVarQueryParameters['limit'] = ObjectSerializer.serialize(limit, "number");
        }

        if (s !== undefined) {
            localVarQueryParameters['s'] = ObjectSerializer.serialize(s, "string");
        }

        if (addHasAugmentations !== undefined) {
            localVarQueryParameters['addHasAugmentations'] = ObjectSerializer.serialize(addHasAugmentations, "boolean");
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body: Array<ImageTargetResponse>;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        body = ObjectSerializer.deserialize(body, "Array<ImageTargetResponse>");
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
    /**
     * Updates properties of a particular Target in your account. Currently following properties are supported: physicalHeight, metadata. 
     * @summary Update Image Target
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param contentType The Content Type of the body. Must be set to application/json.
     * @param tcId Unique identifier of the Image Target Collection.
     * @param targetId Unique identifier of the Image Target.
     * @param updateImageTargetBody 
     */
    public async updateImageTarget (xVersion: string, xToken: string, contentType: string, tcId: string, targetId: string, updateImageTargetBody: UpdateImageTargetBody, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body: ImageTargetResponse;  }> {
        const localVarPath = this.basePath + '/targetCollection/{tcId}/target/{targetId}'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)))
            .replace('{' + 'targetId' + '}', encodeURIComponent(String(targetId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        } else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling updateImageTarget.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling updateImageTarget.');
        }

        // verify required parameter 'contentType' is not null or undefined
        if (contentType === null || contentType === undefined) {
            throw new Error('Required parameter contentType was null or undefined when calling updateImageTarget.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling updateImageTarget.');
        }

        // verify required parameter 'targetId' is not null or undefined
        if (targetId === null || targetId === undefined) {
            throw new Error('Required parameter targetId was null or undefined when calling updateImageTarget.');
        }

        // verify required parameter 'updateImageTargetBody' is not null or undefined
        if (updateImageTargetBody === null || updateImageTargetBody === undefined) {
            throw new Error('Required parameter updateImageTargetBody was null or undefined when calling updateImageTarget.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        localVarHeaderParams['Content-Type'] = ObjectSerializer.serialize(contentType, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'POST',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
            body: ObjectSerializer.serialize(updateImageTargetBody, "UpdateImageTargetBody")
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body: ImageTargetResponse;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        body = ObjectSerializer.deserialize(body, "ImageTargetResponse");
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
}
