/**
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import localVarRequest from 'request';
import http from 'http';

/* tslint:disable:no-unused-locals */
import { CloudArchiveGenerationResponse } from '../model/cloudArchiveGenerationResponse';
import { CreateImageTargetCollectionBody } from '../model/createImageTargetCollectionBody';
import { GenerateWTCBody } from '../model/generateWTCBody';
import { GenerateWTCStatusResponse } from '../model/generateWTCStatusResponse';
import { ImageTargetCollectionResponse } from '../model/imageTargetCollectionResponse';
import { SimilarityCheckBody } from '../model/similarityCheckBody';
import { SimilarityCheckResponse } from '../model/similarityCheckResponse';
import { SimilarityCheckStatusResponse } from '../model/similarityCheckStatusResponse';
import { UpdateImageTargetCollectionBody } from '../model/updateImageTargetCollectionBody';

import { ObjectSerializer, Authentication, VoidAuth, Interceptor } from '../model/models';

import { HttpError, RequestFile } from './apis';

let defaultBasePath = 'https://api-eu.wikitude.com/cloudrecognition';

// ===============================================
// This file is autogenerated - Please do not edit
// ===============================================

export enum ImageTargetCollectionApiApiKeys {
}

export class ImageTargetCollectionApi {
    protected _basePath = defaultBasePath;
    protected _defaultHeaders : any = {};
    protected _useQuerystring : boolean = false;

    protected authentications = {
        'default': <Authentication>new VoidAuth(),
    }

    protected interceptors: Interceptor[] = [];

    constructor(basePath?: string);
    constructor(basePathOrUsername: string, password?: string, basePath?: string) {
        if (password) {
            if (basePath) {
                this.basePath = basePath;
            }
        } else {
            if (basePathOrUsername) {
                this.basePath = basePathOrUsername
            }
        }
    }

    set useQuerystring(value: boolean) {
        this._useQuerystring = value;
    }

    set basePath(basePath: string) {
        this._basePath = basePath;
    }

    set defaultHeaders(defaultHeaders: any) {
        this._defaultHeaders = defaultHeaders;
    }

    get defaultHeaders() {
        return this._defaultHeaders;
    }

    get basePath() {
        return this._basePath;
    }

    public setDefaultAuthentication(auth: Authentication) {
        this.authentications.default = auth;
    }

    public setApiKey(key: ImageTargetCollectionApiApiKeys, value: string) {
        (this.authentications as any)[ImageTargetCollectionApiApiKeys[key]].apiKey = value;
    }

    public addInterceptor(interceptor: Interceptor) {
        this.interceptors.push(interceptor);
    }

    /**
     * Create a new target collection in your account.
     * @summary Create Image Target Collection
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param contentType The Content Type of the body. Must be set to application/json.
     * @param createImageTargetCollectionBody 
     */
    public async createImageTargetCollection (xVersion: string, xToken: string, contentType: string, createImageTargetCollectionBody: CreateImageTargetCollectionBody, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body: ImageTargetCollectionResponse;  }> {
        const localVarPath = this.basePath + '/targetCollection';
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        } else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling createImageTargetCollection.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling createImageTargetCollection.');
        }

        // verify required parameter 'contentType' is not null or undefined
        if (contentType === null || contentType === undefined) {
            throw new Error('Required parameter contentType was null or undefined when calling createImageTargetCollection.');
        }

        // verify required parameter 'createImageTargetCollectionBody' is not null or undefined
        if (createImageTargetCollectionBody === null || createImageTargetCollectionBody === undefined) {
            throw new Error('Required parameter createImageTargetCollectionBody was null or undefined when calling createImageTargetCollection.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        localVarHeaderParams['Content-Type'] = ObjectSerializer.serialize(contentType, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'POST',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
            body: ObjectSerializer.serialize(createImageTargetCollectionBody, "CreateImageTargetCollectionBody")
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body: ImageTargetCollectionResponse;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        body = ObjectSerializer.deserialize(body, "ImageTargetCollectionResponse");
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
    /**
     * Delete a particular target collection from your account.
     * @summary Delete Image Target Collection
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param tcId Unique identifier of the Image Target Collection.
     */
    public async deleteImageTargetCollection (xVersion: string, xToken: string, tcId: string, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body?: any;  }> {
        const localVarPath = this.basePath + '/targetCollection/{tcId}'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling deleteImageTargetCollection.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling deleteImageTargetCollection.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling deleteImageTargetCollection.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'DELETE',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body?: any;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
    /**
     * DEPRECATED - Generate a Cloud Archive from an existing Target Collection. The call is asynchronous and contains a path in the response header (Location) from which the status of the generation can be requested (see Status - Generate Cloud Archive). As of release 4.0.0 this endpoint will return error TARGET_COLLECTION_IS_UP_TO_DATE with status code 412, since the archive will be generated automatically in the background in the future. This endpoint is marked as \"deprecated\" since the behaviour will slightly change. However, this endpoint will still exist in version 3. 
     * @summary Generate Cloud Archive
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param tcId Unique identifier of the Image Target Collection.
     */
    public async generateCloudArchive (xVersion: string, xToken: string, tcId: string, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body: CloudArchiveGenerationResponse;  }> {
        const localVarPath = this.basePath + '/targetCollection/{tcId}/generation/cloudarchive'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        } else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling generateCloudArchive.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling generateCloudArchive.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling generateCloudArchive.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'POST',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body: CloudArchiveGenerationResponse;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        body = ObjectSerializer.deserialize(body, "CloudArchiveGenerationResponse");
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
    /**
     * Generates a WTC file out of an existing Target Collection with up to 1000 targets. The call is asynchronous and contains a path in the response header (Location) from which the status of the generation can be requested (see Status - Generate WTC). 
     * @summary Generate WTC
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param contentType The Content Type of the body. Must be set to application/json.
     * @param tcId Unique identifier of the Image Target Collection.
     * @param generateWTCBody 
     */
    public async generateWTC (xVersion: string, xToken: string, contentType: string, tcId: string, generateWTCBody: GenerateWTCBody, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body: GenerateWTCStatusResponse;  }> {
        const localVarPath = this.basePath + '/targetCollection/{tcId}/generation/wtc'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        } else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling generateWTC.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling generateWTC.');
        }

        // verify required parameter 'contentType' is not null or undefined
        if (contentType === null || contentType === undefined) {
            throw new Error('Required parameter contentType was null or undefined when calling generateWTC.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling generateWTC.');
        }

        // verify required parameter 'generateWTCBody' is not null or undefined
        if (generateWTCBody === null || generateWTCBody === undefined) {
            throw new Error('Required parameter generateWTCBody was null or undefined when calling generateWTC.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        localVarHeaderParams['Content-Type'] = ObjectSerializer.serialize(contentType, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'POST',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
            body: ObjectSerializer.serialize(generateWTCBody, "GenerateWTCBody")
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body: GenerateWTCStatusResponse;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        body = ObjectSerializer.deserialize(body, "GenerateWTCStatusResponse");
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
    /**
     * Retrieves information status about a particular scheduled cloud archive generation.
     * @summary Status - Generate Cloud Archive
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param tcId Unique identifier of the Image Target Collection.
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint.
     */
    public async getCloudArchiveStatus (xVersion: string, xToken: string, tcId: string, generationId: string, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body: CloudArchiveGenerationResponse;  }> {
        const localVarPath = this.basePath + '/targetCollection/{tcId}/generation/cloudarchive/{generationId}'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)))
            .replace('{' + 'generationId' + '}', encodeURIComponent(String(generationId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        } else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling getCloudArchiveStatus.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling getCloudArchiveStatus.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling getCloudArchiveStatus.');
        }

        // verify required parameter 'generationId' is not null or undefined
        if (generationId === null || generationId === undefined) {
            throw new Error('Required parameter generationId was null or undefined when calling getCloudArchiveStatus.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body: CloudArchiveGenerationResponse;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        body = ObjectSerializer.deserialize(body, "CloudArchiveGenerationResponse");
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
    /**
     * Request a particular target collection from your account.
     * @summary Get Image Target Collection
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param tcId Unique identifier of the Image Target Collection.
     */
    public async getImageTargetCollection (xVersion: string, xToken: string, tcId: string, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body: ImageTargetCollectionResponse;  }> {
        const localVarPath = this.basePath + '/targetCollection/{tcId}'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        } else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling getImageTargetCollection.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling getImageTargetCollection.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling getImageTargetCollection.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body: ImageTargetCollectionResponse;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        body = ObjectSerializer.deserialize(body, "ImageTargetCollectionResponse");
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
    /**
     * Request all target collections from your account.
     * @summary Get all Image Target Collections
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param skip Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0
     * @param limit Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000
     */
    public async getImageTargetCollections (xVersion: string, xToken: string, skip?: number, limit?: number, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body: Array<ImageTargetCollectionResponse>;  }> {
        const localVarPath = this.basePath + '/targetCollection';
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        } else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling getImageTargetCollections.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling getImageTargetCollections.');
        }

        if (skip !== undefined) {
            localVarQueryParameters['skip'] = ObjectSerializer.serialize(skip, "number");
        }

        if (limit !== undefined) {
            localVarQueryParameters['limit'] = ObjectSerializer.serialize(limit, "number");
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body: Array<ImageTargetCollectionResponse>;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        body = ObjectSerializer.deserialize(body, "Array<ImageTargetCollectionResponse>");
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
    /**
     * Retrieves information status of a particular scheduled \"Similarity Check\".
     * @summary Status - Similarity Check
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param tcId Unique identifier of the Image Target Collection.
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint.
     */
    public async getSimilarityCheckStatus (xVersion: string, xToken: string, tcId: string, generationId: string, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body: SimilarityCheckStatusResponse;  }> {
        const localVarPath = this.basePath + '/targetCollection/{tcId}/similarity/{generationId}'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)))
            .replace('{' + 'generationId' + '}', encodeURIComponent(String(generationId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        } else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling getSimilarityCheckStatus.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling getSimilarityCheckStatus.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling getSimilarityCheckStatus.');
        }

        // verify required parameter 'generationId' is not null or undefined
        if (generationId === null || generationId === undefined) {
            throw new Error('Required parameter generationId was null or undefined when calling getSimilarityCheckStatus.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body: SimilarityCheckStatusResponse;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        body = ObjectSerializer.deserialize(body, "SimilarityCheckStatusResponse");
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
    /**
     * Retrieves information status about a particular scheduled WTC file generation. Once the status is completed, the WTC information can be retrieved from the Target Collection (see Get Target Collection). 
     * @summary Status - Generate WTC
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param tcId Unique identifier of the Image Target Collection.
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint.
     */
    public async getWTCStatus (xVersion: string, xToken: string, tcId: string, generationId: string, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body: GenerateWTCStatusResponse;  }> {
        const localVarPath = this.basePath + '/targetCollection/{tcId}/generation/wtc/{generationId}'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)))
            .replace('{' + 'generationId' + '}', encodeURIComponent(String(generationId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        } else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling getWTCStatus.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling getWTCStatus.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling getWTCStatus.');
        }

        // verify required parameter 'generationId' is not null or undefined
        if (generationId === null || generationId === undefined) {
            throw new Error('Required parameter generationId was null or undefined when calling getWTCStatus.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body: GenerateWTCStatusResponse;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        body = ObjectSerializer.deserialize(body, "GenerateWTCStatusResponse");
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
    /**
     * Pass up to 10 items pointing to PNG or JPEG images hosted via https in the body. In order to find out whether an image is similar to an existing Target in terms of recognition and tracking behaviour a check is performed per passed image item. The Target Collection must be published and have an active Cloud Archive in place. Up to 5 (default: 1) so called \"candidates\" with a similarity \"score\" are returned per image. Image must be hosted via https and be of type PNG or JPEG. Use \"maxCandidates\" to define the maximum amount of candidates to return for an image. Response header value \"Location\" directly points to the right \"Status - Similarity Check\" endpoint. Best practice is to trigger \"Similarity Check\", wait for \"estimatedLatency\" milliseconds and poll \"Status - Similarity Check\" endpoint every 5 seconds until its \"status\" is \"COMPLETED\". 
     * @summary Similarity Check
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param contentType The Content Type of the body. Must be set to application/json.
     * @param tcId Unique identifier of the Image Target Collection.
     * @param similarityCheckBody 
     */
    public async similarityCheck (xVersion: string, xToken: string, contentType: string, tcId: string, similarityCheckBody: SimilarityCheckBody, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body: SimilarityCheckResponse;  }> {
        const localVarPath = this.basePath + '/targetCollection/{tcId}/similarity'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        } else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling similarityCheck.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling similarityCheck.');
        }

        // verify required parameter 'contentType' is not null or undefined
        if (contentType === null || contentType === undefined) {
            throw new Error('Required parameter contentType was null or undefined when calling similarityCheck.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling similarityCheck.');
        }

        // verify required parameter 'similarityCheckBody' is not null or undefined
        if (similarityCheckBody === null || similarityCheckBody === undefined) {
            throw new Error('Required parameter similarityCheckBody was null or undefined when calling similarityCheck.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        localVarHeaderParams['Content-Type'] = ObjectSerializer.serialize(contentType, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'POST',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
            body: ObjectSerializer.serialize(similarityCheckBody, "SimilarityCheckBody")
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body: SimilarityCheckResponse;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        body = ObjectSerializer.deserialize(body, "SimilarityCheckResponse");
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
    /**
     * Update a target collection from your account.
     * @summary Update Image Target Collection
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param contentType The Content Type of the body. Must be set to application/json.
     * @param tcId Unique identifier of the Image Target Collection.
     * @param updateImageTargetCollectionBody 
     */
    public async updateImageTargetCollection (xVersion: string, xToken: string, contentType: string, tcId: string, updateImageTargetCollectionBody: UpdateImageTargetCollectionBody, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body: ImageTargetCollectionResponse;  }> {
        const localVarPath = this.basePath + '/targetCollection/{tcId}'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        } else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling updateImageTargetCollection.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling updateImageTargetCollection.');
        }

        // verify required parameter 'contentType' is not null or undefined
        if (contentType === null || contentType === undefined) {
            throw new Error('Required parameter contentType was null or undefined when calling updateImageTargetCollection.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling updateImageTargetCollection.');
        }

        // verify required parameter 'updateImageTargetCollectionBody' is not null or undefined
        if (updateImageTargetCollectionBody === null || updateImageTargetCollectionBody === undefined) {
            throw new Error('Required parameter updateImageTargetCollectionBody was null or undefined when calling updateImageTargetCollection.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        localVarHeaderParams['Content-Type'] = ObjectSerializer.serialize(contentType, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'POST',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
            body: ObjectSerializer.serialize(updateImageTargetCollectionBody, "UpdateImageTargetCollectionBody")
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body: ImageTargetCollectionResponse;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        body = ObjectSerializer.deserialize(body, "ImageTargetCollectionResponse");
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
}
