/**
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import localVarRequest from 'request';
import http from 'http';

/* tslint:disable:no-unused-locals */
import { CreateObjectTargetImagesBody } from '../model/createObjectTargetImagesBody';
import { CreateObjectTargetWTOBody } from '../model/createObjectTargetWTOBody';
import { ExtendObjectTargetBody } from '../model/extendObjectTargetBody';
import { ObjectTargetJobResponse } from '../model/objectTargetJobResponse';
import { ObjectTargetResponse } from '../model/objectTargetResponse';
import { RenameObjectTargetBody } from '../model/renameObjectTargetBody';

import { ObjectSerializer, Authentication, VoidAuth, Interceptor } from '../model/models';

import { HttpError, RequestFile } from './apis';

let defaultBasePath = 'https://api-eu.wikitude.com/cloudrecognition';

// ===============================================
// This file is autogenerated - Please do not edit
// ===============================================

export enum ObjectTargetApiApiKeys {
}

export class ObjectTargetApi {
    protected _basePath = defaultBasePath;
    protected _defaultHeaders : any = {};
    protected _useQuerystring : boolean = false;

    protected authentications = {
        'default': <Authentication>new VoidAuth(),
    }

    protected interceptors: Interceptor[] = [];

    constructor(basePath?: string);
    constructor(basePathOrUsername: string, password?: string, basePath?: string) {
        if (password) {
            if (basePath) {
                this.basePath = basePath;
            }
        } else {
            if (basePathOrUsername) {
                this.basePath = basePathOrUsername
            }
        }
    }

    set useQuerystring(value: boolean) {
        this._useQuerystring = value;
    }

    set basePath(basePath: string) {
        this._basePath = basePath;
    }

    set defaultHeaders(defaultHeaders: any) {
        this._defaultHeaders = defaultHeaders;
    }

    get defaultHeaders() {
        return this._defaultHeaders;
    }

    get basePath() {
        return this._basePath;
    }

    public setDefaultAuthentication(auth: Authentication) {
        this.authentications.default = auth;
    }

    public setApiKey(key: ObjectTargetApiApiKeys, value: string) {
        (this.authentications as any)[ObjectTargetApiApiKeys[key]].apiKey = value;
    }

    public addInterceptor(interceptor: Interceptor) {
        this.interceptors.push(interceptor);
    }

    /**
     * Create a new Object Target in an Object Target Collection from at least two Image files.
     * @summary Create Object Target from Images
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param contentType The Content Type of the body. Must be set to application/json.
     * @param tcId Unique identifier of the Object Target Collection.
     * @param createObjectTargetImagesBody 
     */
    public async createObjectTargetFromImages (xVersion: string, xToken: string, contentType: string, tcId: string, createObjectTargetImagesBody: CreateObjectTargetImagesBody, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body: ObjectTargetJobResponse;  }> {
        const localVarPath = this.basePath + '/objectTargetCollection/{tcId}/target/images'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        } else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling createObjectTargetFromImages.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling createObjectTargetFromImages.');
        }

        // verify required parameter 'contentType' is not null or undefined
        if (contentType === null || contentType === undefined) {
            throw new Error('Required parameter contentType was null or undefined when calling createObjectTargetFromImages.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling createObjectTargetFromImages.');
        }

        // verify required parameter 'createObjectTargetImagesBody' is not null or undefined
        if (createObjectTargetImagesBody === null || createObjectTargetImagesBody === undefined) {
            throw new Error('Required parameter createObjectTargetImagesBody was null or undefined when calling createObjectTargetFromImages.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        localVarHeaderParams['Content-Type'] = ObjectSerializer.serialize(contentType, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'POST',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
            body: ObjectSerializer.serialize(createObjectTargetImagesBody, "CreateObjectTargetImagesBody")
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body: ObjectTargetJobResponse;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        body = ObjectSerializer.deserialize(body, "ObjectTargetJobResponse");
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
    /**
     * Create a new Object Target in an Object Target Collection from a WTO file.
     * @summary Create Object Target from WTO
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param contentType The Content Type of the body. Must be set to application/json.
     * @param tcId Unique identifier of the Object Target Collection.
     * @param createObjectTargetWTOBody 
     */
    public async createObjectTargetFromWTO (xVersion: string, xToken: string, contentType: string, tcId: string, createObjectTargetWTOBody: CreateObjectTargetWTOBody, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body: ObjectTargetJobResponse;  }> {
        const localVarPath = this.basePath + '/objectTargetCollection/{tcId}/target/wto'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        } else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling createObjectTargetFromWTO.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling createObjectTargetFromWTO.');
        }

        // verify required parameter 'contentType' is not null or undefined
        if (contentType === null || contentType === undefined) {
            throw new Error('Required parameter contentType was null or undefined when calling createObjectTargetFromWTO.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling createObjectTargetFromWTO.');
        }

        // verify required parameter 'createObjectTargetWTOBody' is not null or undefined
        if (createObjectTargetWTOBody === null || createObjectTargetWTOBody === undefined) {
            throw new Error('Required parameter createObjectTargetWTOBody was null or undefined when calling createObjectTargetFromWTO.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        localVarHeaderParams['Content-Type'] = ObjectSerializer.serialize(contentType, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'POST',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
            body: ObjectSerializer.serialize(createObjectTargetWTOBody, "CreateObjectTargetWTOBody")
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body: ObjectTargetJobResponse;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        body = ObjectSerializer.deserialize(body, "ObjectTargetJobResponse");
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
    /**
     * Delete a particular Object Target from your Object Target Collection.
     * @summary Delete Object Target
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param tcId Unique identifier of the Object Target Collection.
     * @param targetId Unique identifier of the Object Target.
     */
    public async deleteObjectTarget (xVersion: string, xToken: string, tcId: string, targetId: string, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body?: any;  }> {
        const localVarPath = this.basePath + '/objectTargetCollection/{tcId}/target/{targetId}'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)))
            .replace('{' + 'targetId' + '}', encodeURIComponent(String(targetId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling deleteObjectTarget.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling deleteObjectTarget.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling deleteObjectTarget.');
        }

        // verify required parameter 'targetId' is not null or undefined
        if (targetId === null || targetId === undefined) {
            throw new Error('Required parameter targetId was null or undefined when calling deleteObjectTarget.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'DELETE',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body?: any;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
    /**
     * Add source images to an existing target.
     * @summary Extend Object Target
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param contentType The Content Type of the body. Must be set to application/json.
     * @param tcId Unique identifier of the Object Target Collection.
     * @param targetId Unique identifier of the Object Target.
     * @param extendObjectTargetBody 
     */
    public async extendObjectTarget (xVersion: string, xToken: string, contentType: string, tcId: string, targetId: string, extendObjectTargetBody: ExtendObjectTargetBody, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body: ObjectTargetJobResponse;  }> {
        const localVarPath = this.basePath + '/objectTargetCollection/{tcId}/target/{targetId}'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)))
            .replace('{' + 'targetId' + '}', encodeURIComponent(String(targetId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        } else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling extendObjectTarget.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling extendObjectTarget.');
        }

        // verify required parameter 'contentType' is not null or undefined
        if (contentType === null || contentType === undefined) {
            throw new Error('Required parameter contentType was null or undefined when calling extendObjectTarget.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling extendObjectTarget.');
        }

        // verify required parameter 'targetId' is not null or undefined
        if (targetId === null || targetId === undefined) {
            throw new Error('Required parameter targetId was null or undefined when calling extendObjectTarget.');
        }

        // verify required parameter 'extendObjectTargetBody' is not null or undefined
        if (extendObjectTargetBody === null || extendObjectTargetBody === undefined) {
            throw new Error('Required parameter extendObjectTargetBody was null or undefined when calling extendObjectTarget.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        localVarHeaderParams['Content-Type'] = ObjectSerializer.serialize(contentType, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'PUT',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
            body: ObjectSerializer.serialize(extendObjectTargetBody, "ExtendObjectTargetBody")
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body: ObjectTargetJobResponse;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        body = ObjectSerializer.deserialize(body, "ObjectTargetJobResponse");
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
    /**
     * Request a specific Object Targets from your account.
     * @summary Get Object Target
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param tcId Unique identifier of the Object Target Collection.
     * @param targetId Unique identifier of the Object Target.
     */
    public async getObjectTarget (xVersion: string, xToken: string, tcId: string, targetId: string, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body: ObjectTargetResponse;  }> {
        const localVarPath = this.basePath + '/objectTargetCollection/{tcId}/target/{targetId}'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)))
            .replace('{' + 'targetId' + '}', encodeURIComponent(String(targetId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        } else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling getObjectTarget.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling getObjectTarget.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling getObjectTarget.');
        }

        // verify required parameter 'targetId' is not null or undefined
        if (targetId === null || targetId === undefined) {
            throw new Error('Required parameter targetId was null or undefined when calling getObjectTarget.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body: ObjectTargetResponse;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        body = ObjectSerializer.deserialize(body, "ObjectTargetResponse");
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
    /**
     * Retrieves information status about a particular scheduled Object Target creation.
     * @summary Status - Object Target Generation Information
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param tcId Unique identifier of the Object Target Collection.
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint.
     */
    public async getObjectTargetStatus (xVersion: string, xToken: string, tcId: string, generationId: string, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body: ObjectTargetJobResponse;  }> {
        const localVarPath = this.basePath + '/objectTargetCollection/{tcId}/generation/targets/{generationId}'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)))
            .replace('{' + 'generationId' + '}', encodeURIComponent(String(generationId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        } else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling getObjectTargetStatus.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling getObjectTargetStatus.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling getObjectTargetStatus.');
        }

        // verify required parameter 'generationId' is not null or undefined
        if (generationId === null || generationId === undefined) {
            throw new Error('Required parameter generationId was null or undefined when calling getObjectTargetStatus.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body: ObjectTargetJobResponse;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        body = ObjectSerializer.deserialize(body, "ObjectTargetJobResponse");
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
    /**
     * Request all Object Targets in a Target Collection.
     * @summary Get Object Targets
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param tcId Unique identifier of the Object Target Collection.
     */
    public async getObjectTargets (xVersion: string, xToken: string, tcId: string, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body: Array<ObjectTargetResponse>;  }> {
        const localVarPath = this.basePath + '/objectTargetCollection/{tcId}/target'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        } else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling getObjectTargets.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling getObjectTargets.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling getObjectTargets.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'GET',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body: Array<ObjectTargetResponse>;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        body = ObjectSerializer.deserialize(body, "Array<ObjectTargetResponse>");
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
    /**
     * Rename an existing target.
     * @summary Rename Object Target
     * @param xVersion The version of the API to be used. Must be set to 3.
     * @param xToken Your Manager Token.
     * @param contentType The Content Type of the body. Must be set to application/json.
     * @param tcId Unique identifier of the Object Target Collection.
     * @param targetId Unique identifier of the Object Target.
     * @param renameObjectTargetBody 
     */
    public async renameObjectTarget (xVersion: string, xToken: string, contentType: string, tcId: string, targetId: string, renameObjectTargetBody: RenameObjectTargetBody, options: {headers: {[name: string]: string}} = {headers: {}}) : Promise<{ response: http.IncomingMessage; body: ObjectTargetJobResponse;  }> {
        const localVarPath = this.basePath + '/objectTargetCollection/{tcId}/target/{targetId}/name'
            .replace('{' + 'tcId' + '}', encodeURIComponent(String(tcId)))
            .replace('{' + 'targetId' + '}', encodeURIComponent(String(targetId)));
        let localVarQueryParameters: any = {};
        let localVarHeaderParams: any = (<any>Object).assign({}, this._defaultHeaders);
        const produces = ['application/json'];
        // give precedence to 'application/json'
        if (produces.indexOf('application/json') >= 0) {
            localVarHeaderParams.Accept = 'application/json';
        } else {
            localVarHeaderParams.Accept = produces.join(',');
        }
        let localVarFormParams: any = {};

        // verify required parameter 'xVersion' is not null or undefined
        if (xVersion === null || xVersion === undefined) {
            throw new Error('Required parameter xVersion was null or undefined when calling renameObjectTarget.');
        }

        // verify required parameter 'xToken' is not null or undefined
        if (xToken === null || xToken === undefined) {
            throw new Error('Required parameter xToken was null or undefined when calling renameObjectTarget.');
        }

        // verify required parameter 'contentType' is not null or undefined
        if (contentType === null || contentType === undefined) {
            throw new Error('Required parameter contentType was null or undefined when calling renameObjectTarget.');
        }

        // verify required parameter 'tcId' is not null or undefined
        if (tcId === null || tcId === undefined) {
            throw new Error('Required parameter tcId was null or undefined when calling renameObjectTarget.');
        }

        // verify required parameter 'targetId' is not null or undefined
        if (targetId === null || targetId === undefined) {
            throw new Error('Required parameter targetId was null or undefined when calling renameObjectTarget.');
        }

        // verify required parameter 'renameObjectTargetBody' is not null or undefined
        if (renameObjectTargetBody === null || renameObjectTargetBody === undefined) {
            throw new Error('Required parameter renameObjectTargetBody was null or undefined when calling renameObjectTarget.');
        }

        localVarHeaderParams['X-Version'] = ObjectSerializer.serialize(xVersion, "string");
        localVarHeaderParams['X-Token'] = ObjectSerializer.serialize(xToken, "string");
        localVarHeaderParams['Content-Type'] = ObjectSerializer.serialize(contentType, "string");
        (<any>Object).assign(localVarHeaderParams, options.headers);

        let localVarUseFormData = false;

        let localVarRequestOptions: localVarRequest.Options = {
            method: 'PUT',
            qs: localVarQueryParameters,
            headers: localVarHeaderParams,
            uri: localVarPath,
            useQuerystring: this._useQuerystring,
            json: true,
            body: ObjectSerializer.serialize(renameObjectTargetBody, "RenameObjectTargetBody")
        };

        let authenticationPromise = Promise.resolve();
        authenticationPromise = authenticationPromise.then(() => this.authentications.default.applyToRequest(localVarRequestOptions));

        let interceptorPromise = authenticationPromise;
        for (const interceptor of this.interceptors) {
            interceptorPromise = interceptorPromise.then(() => interceptor(localVarRequestOptions));
        }

        return interceptorPromise.then(() => {
            if (Object.keys(localVarFormParams).length) {
                if (localVarUseFormData) {
                    (<any>localVarRequestOptions).formData = localVarFormParams;
                } else {
                    localVarRequestOptions.form = localVarFormParams;
                }
            }
            return new Promise<{ response: http.IncomingMessage; body: ObjectTargetJobResponse;  }>((resolve, reject) => {
                localVarRequest(localVarRequestOptions, (error, response, body) => {
                    if (error) {
                        reject(error);
                    } else {
                        body = ObjectSerializer.deserialize(body, "ObjectTargetJobResponse");
                        if (response.statusCode && response.statusCode >= 200 && response.statusCode <= 299) {
                            resolve({ response: response, body: body });
                        } else {
                            reject(new HttpError(response, body, response.statusCode));
                        }
                    }
                });
            });
        });
    }
}
