/**
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from './models';
import { GenerateHeatmapResponseInputParams } from './generateHeatmapResponseInputParams';
import { GenerateHeatmapStatusResponsePayload } from './generateHeatmapStatusResponsePayload';

export class GenerateHeatmapStatusResponse {
    'inputParams'?: GenerateHeatmapResponseInputParams;
    'payload'?: GenerateHeatmapStatusResponsePayload;
    /**
    * Timestamp of the job creation.
    */
    'creationDate'?: number;
    /**
    * Estimation of when the job will start processing.
    */
    'estimatedStart'?: number;
    /**
    * Estimation of when the job will approximately be finished.
    */
    'estimatedEnd'?: number;
    /**
    * Recommendation of when to first poll the corresponding status endpoint in milliseconds.
    */
    'estimatedLatency'?: number;
    /**
    * The status of the asynchronous job.
    */
    'status'?: string;
    /**
    * The asynchronous job id.
    */
    'id'?: string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "inputParams",
            "baseName": "inputParams",
            "type": "GenerateHeatmapResponseInputParams"
        },
        {
            "name": "payload",
            "baseName": "payload",
            "type": "GenerateHeatmapStatusResponsePayload"
        },
        {
            "name": "creationDate",
            "baseName": "creationDate",
            "type": "number"
        },
        {
            "name": "estimatedStart",
            "baseName": "estimatedStart",
            "type": "number"
        },
        {
            "name": "estimatedEnd",
            "baseName": "estimatedEnd",
            "type": "number"
        },
        {
            "name": "estimatedLatency",
            "baseName": "estimatedLatency",
            "type": "number"
        },
        {
            "name": "status",
            "baseName": "status",
            "type": "string"
        },
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return GenerateHeatmapStatusResponse.attributeTypeMap;
    }
}

