/**
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from './models';

export class GenerateWTCStatusResponse {
    /**
    * Object containing job relevant results.
    */
    'payload'?: object;
    /**
    * Estimation of when the job will start processing.
    */
    'estimatedStart'?: number;
    /**
    * Estimation of when the job will approximately be finished.
    */
    'estimatedEnd'?: number;
    /**
    * The status of the asynchronous job.
    */
    'status'?: string;
    /**
    * Unique identifier of the Target Collection.
    */
    'id'?: string;
    /**
    * The e-mail address, the notification is sent after the generation of the resource is finished.
    */
    'eMail'?: string;
    /**
    * The asynchronous job id.
    */
    'generationId'?: string;
    /**
    * Timestamp of the job creation.
    */
    'created'?: number;
    /**
    * Version of the Wikitude SDK the WTC resource was generated for.
    */
    'sdkVersion'?: string;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "payload",
            "baseName": "payload",
            "type": "object"
        },
        {
            "name": "estimatedStart",
            "baseName": "estimatedStart",
            "type": "number"
        },
        {
            "name": "estimatedEnd",
            "baseName": "estimatedEnd",
            "type": "number"
        },
        {
            "name": "status",
            "baseName": "status",
            "type": "string"
        },
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "eMail",
            "baseName": "eMail",
            "type": "string"
        },
        {
            "name": "generationId",
            "baseName": "generationId",
            "type": "string"
        },
        {
            "name": "created",
            "baseName": "created",
            "type": "number"
        },
        {
            "name": "sdkVersion",
            "baseName": "sdkVersion",
            "type": "string"
        }    ];

    static getAttributeTypeMap() {
        return GenerateWTCStatusResponse.attributeTypeMap;
    }
}

