/**
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from './models';
import { ImageTargetCollectionResponseCloudArchive } from './imageTargetCollectionResponseCloudArchive';
import { ImageTargetCollectionResponseWtc } from './imageTargetCollectionResponseWtc';

export class ImageTargetCollectionResponse {
    /**
    * Unique identifier of the Target Collection.
    */
    'id'?: string;
    /**
    * Name of the Target Collection.
    */
    'name'?: string;
    /**
    * Type of the Target Collection (\"ImageTargetCollection\" or \"ObjectTargetCollection\").
    */
    'type'?: string;
    /**
    * A list of generated WTC files.
    */
    'wtc'?: Array<ImageTargetCollectionResponseWtc>;
    /**
    * Modification timestamp.
    */
    'modDat'?: number;
    /**
    * Creation timestamp.
    */
    'creDat'?: number;
    /**
    * Arbitrary JSON data that should be stored together with the Target Collection.
    */
    'metadata'?: object;
    'cloudArchive'?: ImageTargetCollectionResponseCloudArchive;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "type",
            "baseName": "type",
            "type": "string"
        },
        {
            "name": "wtc",
            "baseName": "wtc",
            "type": "Array<ImageTargetCollectionResponseWtc>"
        },
        {
            "name": "modDat",
            "baseName": "modDat",
            "type": "number"
        },
        {
            "name": "creDat",
            "baseName": "creDat",
            "type": "number"
        },
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "object"
        },
        {
            "name": "cloudArchive",
            "baseName": "cloudArchive",
            "type": "ImageTargetCollectionResponseCloudArchive"
        }    ];

    static getAttributeTypeMap() {
        return ImageTargetCollectionResponse.attributeTypeMap;
    }
}

