/**
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from './models';

export class ImageTargetResponse {
    /**
    * URL to the Target resource thumbnail.
    */
    'thumbnailUrl'?: string;
    /**
    * The star rating indicates the quality of the target, i.e. how well the target is recognized on the device. The more stars a target has, the better it can be recognized and tracked. 
    */
    'rating'?: number;
    /**
    * The distribution rating indicates how well feature-points scatter over the target image. The higher the rating, the more reliable it can be recognized and tracked, even if partly covered. 
    */
    'distribution'?: number;
    /**
    * File size of the stored resource.
    */
    'fileSize'?: number;
    /**
    * Name of the Target.
    */
    'name'?: string;
    /**
    * URL to the Target Image resource.
    */
    'imageUrl'?: string;
    /**
    * Type of the Target (\"Image\" for Image Targets or \"Object\" for Object Targets).
    */
    'type'?: string;
    /**
    * Modification timestamp.
    */
    'modDat'?: number;
    /**
    * Creation timestamp.
    */
    'creDat'?: number;
    /**
    * Unique identifier of the Target.
    */
    'id'?: string;
    /**
    * Arbitrary JSON data that should be stored together with the Target.
    */
    'metadata'?: string;
    /**
    * The physical (real world) height of the target, in millimeters.
    */
    'physicalHeight'?: number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "thumbnailUrl",
            "baseName": "thumbnailUrl",
            "type": "string"
        },
        {
            "name": "rating",
            "baseName": "rating",
            "type": "number"
        },
        {
            "name": "distribution",
            "baseName": "distribution",
            "type": "number"
        },
        {
            "name": "fileSize",
            "baseName": "fileSize",
            "type": "number"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "imageUrl",
            "baseName": "imageUrl",
            "type": "string"
        },
        {
            "name": "type",
            "baseName": "type",
            "type": "string"
        },
        {
            "name": "modDat",
            "baseName": "modDat",
            "type": "number"
        },
        {
            "name": "creDat",
            "baseName": "creDat",
            "type": "number"
        },
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "metadata",
            "baseName": "metadata",
            "type": "string"
        },
        {
            "name": "physicalHeight",
            "baseName": "physicalHeight",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return ImageTargetResponse.attributeTypeMap;
    }
}

