import localVarRequest from 'request';

export * from './cloudArchiveGenerationResponse';
export * from './cloudArchiveGenerationResponseInputParams';
export * from './createImageTargetCollectionBody';
export * from './createImageTargetCollectionBodyCloudArchive';
export * from './createImageTargetsBody';
export * from './createImageTargetsResponse';
export * from './createImageTargetsResponseInputParams';
export * from './createImageTargetsResponseInputParamsTargets';
export * from './createObjectTargetCollectionBody';
export * from './createObjectTargetImagesBody';
export * from './createObjectTargetImagesBodyResource';
export * from './createObjectTargetWTOBody';
export * from './createObjectTargetWTOBodyResource';
export * from './extendObjectTargetBody';
export * from './generateHeatmapBody';
export * from './generateHeatmapResponse';
export * from './generateHeatmapResponseInputParams';
export * from './generateHeatmapStatusResponse';
export * from './generateHeatmapStatusResponsePayload';
export * from './generateWTCBody';
export * from './generateWTCStatusResponse';
export * from './generateWTOBody';
export * from './getAccountInfoResponse';
export * from './getAccountInfoResponseStorage';
export * from './imageTargetCollectionResponse';
export * from './imageTargetCollectionResponseCloudArchive';
export * from './imageTargetCollectionResponseWtc';
export * from './imageTargetResponse';
export * from './objectTargetCollectionJobResponse';
export * from './objectTargetCollectionResponse';
export * from './objectTargetCollectionResponseWto';
export * from './objectTargetJobResponse';
export * from './objectTargetResponse';
export * from './objectTargetResponseResource';
export * from './objectTargetResponseWtoFile';
export * from './renameObjectTargetBody';
export * from './similarityCheckBody';
export * from './similarityCheckBodyImages';
export * from './similarityCheckResponse';
export * from './similarityCheckResponseInputParams';
export * from './similarityCheckResponseInputParamsImages';
export * from './similarityCheckStatusResponse';
export * from './similarityCheckStatusResponseCandidates';
export * from './similarityCheckStatusResponseInputParams';
export * from './similarityCheckStatusResponsePayload';
export * from './updateImageTargetBody';
export * from './updateImageTargetCollectionBody';
export * from './updateObjectTargetCollectionBody';

import * as fs from 'fs';

export interface RequestDetailedFile {
    value: Buffer;
    options?: {
        filename?: string;
        contentType?: string;
    }
}

export type RequestFile = string | Buffer | fs.ReadStream | RequestDetailedFile;


import { CloudArchiveGenerationResponse } from './cloudArchiveGenerationResponse';
import { CloudArchiveGenerationResponseInputParams } from './cloudArchiveGenerationResponseInputParams';
import { CreateImageTargetCollectionBody } from './createImageTargetCollectionBody';
import { CreateImageTargetCollectionBodyCloudArchive } from './createImageTargetCollectionBodyCloudArchive';
import { CreateImageTargetsBody } from './createImageTargetsBody';
import { CreateImageTargetsResponse } from './createImageTargetsResponse';
import { CreateImageTargetsResponseInputParams } from './createImageTargetsResponseInputParams';
import { CreateImageTargetsResponseInputParamsTargets } from './createImageTargetsResponseInputParamsTargets';
import { CreateObjectTargetCollectionBody } from './createObjectTargetCollectionBody';
import { CreateObjectTargetImagesBody } from './createObjectTargetImagesBody';
import { CreateObjectTargetImagesBodyResource } from './createObjectTargetImagesBodyResource';
import { CreateObjectTargetWTOBody } from './createObjectTargetWTOBody';
import { CreateObjectTargetWTOBodyResource } from './createObjectTargetWTOBodyResource';
import { ExtendObjectTargetBody } from './extendObjectTargetBody';
import { GenerateHeatmapBody } from './generateHeatmapBody';
import { GenerateHeatmapResponse } from './generateHeatmapResponse';
import { GenerateHeatmapResponseInputParams } from './generateHeatmapResponseInputParams';
import { GenerateHeatmapStatusResponse } from './generateHeatmapStatusResponse';
import { GenerateHeatmapStatusResponsePayload } from './generateHeatmapStatusResponsePayload';
import { GenerateWTCBody } from './generateWTCBody';
import { GenerateWTCStatusResponse } from './generateWTCStatusResponse';
import { GenerateWTOBody } from './generateWTOBody';
import { GetAccountInfoResponse } from './getAccountInfoResponse';
import { GetAccountInfoResponseStorage } from './getAccountInfoResponseStorage';
import { ImageTargetCollectionResponse } from './imageTargetCollectionResponse';
import { ImageTargetCollectionResponseCloudArchive } from './imageTargetCollectionResponseCloudArchive';
import { ImageTargetCollectionResponseWtc } from './imageTargetCollectionResponseWtc';
import { ImageTargetResponse } from './imageTargetResponse';
import { ObjectTargetCollectionJobResponse } from './objectTargetCollectionJobResponse';
import { ObjectTargetCollectionResponse } from './objectTargetCollectionResponse';
import { ObjectTargetCollectionResponseWto } from './objectTargetCollectionResponseWto';
import { ObjectTargetJobResponse } from './objectTargetJobResponse';
import { ObjectTargetResponse } from './objectTargetResponse';
import { ObjectTargetResponseResource } from './objectTargetResponseResource';
import { ObjectTargetResponseWtoFile } from './objectTargetResponseWtoFile';
import { RenameObjectTargetBody } from './renameObjectTargetBody';
import { SimilarityCheckBody } from './similarityCheckBody';
import { SimilarityCheckBodyImages } from './similarityCheckBodyImages';
import { SimilarityCheckResponse } from './similarityCheckResponse';
import { SimilarityCheckResponseInputParams } from './similarityCheckResponseInputParams';
import { SimilarityCheckResponseInputParamsImages } from './similarityCheckResponseInputParamsImages';
import { SimilarityCheckStatusResponse } from './similarityCheckStatusResponse';
import { SimilarityCheckStatusResponseCandidates } from './similarityCheckStatusResponseCandidates';
import { SimilarityCheckStatusResponseInputParams } from './similarityCheckStatusResponseInputParams';
import { SimilarityCheckStatusResponsePayload } from './similarityCheckStatusResponsePayload';
import { UpdateImageTargetBody } from './updateImageTargetBody';
import { UpdateImageTargetCollectionBody } from './updateImageTargetCollectionBody';
import { UpdateObjectTargetCollectionBody } from './updateObjectTargetCollectionBody';

/* tslint:disable:no-unused-variable */
let primitives = [
                    "string",
                    "boolean",
                    "double",
                    "integer",
                    "long",
                    "float",
                    "number",
                    "any"
                 ];

let enumsMap: {[index: string]: any} = {
}

let typeMap: {[index: string]: any} = {
    "CloudArchiveGenerationResponse": CloudArchiveGenerationResponse,
    "CloudArchiveGenerationResponseInputParams": CloudArchiveGenerationResponseInputParams,
    "CreateImageTargetCollectionBody": CreateImageTargetCollectionBody,
    "CreateImageTargetCollectionBodyCloudArchive": CreateImageTargetCollectionBodyCloudArchive,
    "CreateImageTargetsBody": CreateImageTargetsBody,
    "CreateImageTargetsResponse": CreateImageTargetsResponse,
    "CreateImageTargetsResponseInputParams": CreateImageTargetsResponseInputParams,
    "CreateImageTargetsResponseInputParamsTargets": CreateImageTargetsResponseInputParamsTargets,
    "CreateObjectTargetCollectionBody": CreateObjectTargetCollectionBody,
    "CreateObjectTargetImagesBody": CreateObjectTargetImagesBody,
    "CreateObjectTargetImagesBodyResource": CreateObjectTargetImagesBodyResource,
    "CreateObjectTargetWTOBody": CreateObjectTargetWTOBody,
    "CreateObjectTargetWTOBodyResource": CreateObjectTargetWTOBodyResource,
    "ExtendObjectTargetBody": ExtendObjectTargetBody,
    "GenerateHeatmapBody": GenerateHeatmapBody,
    "GenerateHeatmapResponse": GenerateHeatmapResponse,
    "GenerateHeatmapResponseInputParams": GenerateHeatmapResponseInputParams,
    "GenerateHeatmapStatusResponse": GenerateHeatmapStatusResponse,
    "GenerateHeatmapStatusResponsePayload": GenerateHeatmapStatusResponsePayload,
    "GenerateWTCBody": GenerateWTCBody,
    "GenerateWTCStatusResponse": GenerateWTCStatusResponse,
    "GenerateWTOBody": GenerateWTOBody,
    "GetAccountInfoResponse": GetAccountInfoResponse,
    "GetAccountInfoResponseStorage": GetAccountInfoResponseStorage,
    "ImageTargetCollectionResponse": ImageTargetCollectionResponse,
    "ImageTargetCollectionResponseCloudArchive": ImageTargetCollectionResponseCloudArchive,
    "ImageTargetCollectionResponseWtc": ImageTargetCollectionResponseWtc,
    "ImageTargetResponse": ImageTargetResponse,
    "ObjectTargetCollectionJobResponse": ObjectTargetCollectionJobResponse,
    "ObjectTargetCollectionResponse": ObjectTargetCollectionResponse,
    "ObjectTargetCollectionResponseWto": ObjectTargetCollectionResponseWto,
    "ObjectTargetJobResponse": ObjectTargetJobResponse,
    "ObjectTargetResponse": ObjectTargetResponse,
    "ObjectTargetResponseResource": ObjectTargetResponseResource,
    "ObjectTargetResponseWtoFile": ObjectTargetResponseWtoFile,
    "RenameObjectTargetBody": RenameObjectTargetBody,
    "SimilarityCheckBody": SimilarityCheckBody,
    "SimilarityCheckBodyImages": SimilarityCheckBodyImages,
    "SimilarityCheckResponse": SimilarityCheckResponse,
    "SimilarityCheckResponseInputParams": SimilarityCheckResponseInputParams,
    "SimilarityCheckResponseInputParamsImages": SimilarityCheckResponseInputParamsImages,
    "SimilarityCheckStatusResponse": SimilarityCheckStatusResponse,
    "SimilarityCheckStatusResponseCandidates": SimilarityCheckStatusResponseCandidates,
    "SimilarityCheckStatusResponseInputParams": SimilarityCheckStatusResponseInputParams,
    "SimilarityCheckStatusResponsePayload": SimilarityCheckStatusResponsePayload,
    "UpdateImageTargetBody": UpdateImageTargetBody,
    "UpdateImageTargetCollectionBody": UpdateImageTargetCollectionBody,
    "UpdateObjectTargetCollectionBody": UpdateObjectTargetCollectionBody,
}

export class ObjectSerializer {
    public static findCorrectType(data: any, expectedType: string) {
        if (data == undefined) {
            return expectedType;
        } else if (primitives.indexOf(expectedType.toLowerCase()) !== -1) {
            return expectedType;
        } else if (expectedType === "Date") {
            return expectedType;
        } else {
            if (enumsMap[expectedType]) {
                return expectedType;
            }

            if (!typeMap[expectedType]) {
                return expectedType; // w/e we don't know the type
            }

            // Check the discriminator
            let discriminatorProperty = typeMap[expectedType].discriminator;
            if (discriminatorProperty == null) {
                return expectedType; // the type does not have a discriminator. use it.
            } else {
                if (data[discriminatorProperty]) {
                    var discriminatorType = data[discriminatorProperty];
                    if(typeMap[discriminatorType]){
                        return discriminatorType; // use the type given in the discriminator
                    } else {
                        return expectedType; // discriminator did not map to a type
                    }
                } else {
                    return expectedType; // discriminator was not present (or an empty string)
                }
            }
        }
    }

    public static serialize(data: any, type: string) {
        if (data == undefined) {
            return data;
        } else if (primitives.indexOf(type.toLowerCase()) !== -1) {
            return data;
        } else if (type.lastIndexOf("Array<", 0) === 0) { // string.startsWith pre es6
            let subType: string = type.replace("Array<", ""); // Array<Type> => Type>
            subType = subType.substring(0, subType.length - 1); // Type> => Type
            let transformedData: any[] = [];
            for (let index = 0; index < data.length; index++) {
                let datum = data[index];
                transformedData.push(ObjectSerializer.serialize(datum, subType));
            }
            return transformedData;
        } else if (type === "Date") {
            return data.toISOString();
        } else {
            if (enumsMap[type]) {
                return data;
            }
            if (!typeMap[type]) { // in case we dont know the type
                return data;
            }

            // Get the actual type of this object
            type = this.findCorrectType(data, type);

            // get the map for the correct type.
            let attributeTypes = typeMap[type].getAttributeTypeMap();
            let instance: {[index: string]: any} = {};
            for (let index = 0; index < attributeTypes.length; index++) {
                let attributeType = attributeTypes[index];
                instance[attributeType.baseName] = ObjectSerializer.serialize(data[attributeType.name], attributeType.type);
            }
            return instance;
        }
    }

    public static deserialize(data: any, type: string) {
        // polymorphism may change the actual type.
        type = ObjectSerializer.findCorrectType(data, type);
        if (data == undefined) {
            return data;
        } else if (primitives.indexOf(type.toLowerCase()) !== -1) {
            return data;
        } else if (type.lastIndexOf("Array<", 0) === 0) { // string.startsWith pre es6
            let subType: string = type.replace("Array<", ""); // Array<Type> => Type>
            subType = subType.substring(0, subType.length - 1); // Type> => Type
            let transformedData: any[] = [];
            for (let index = 0; index < data.length; index++) {
                let datum = data[index];
                transformedData.push(ObjectSerializer.deserialize(datum, subType));
            }
            return transformedData;
        } else if (type === "Date") {
            return new Date(data);
        } else {
            if (enumsMap[type]) {// is Enum
                return data;
            }

            if (!typeMap[type]) { // dont know the type
                return data;
            }
            let instance = new typeMap[type]();
            let attributeTypes = typeMap[type].getAttributeTypeMap();
            for (let index = 0; index < attributeTypes.length; index++) {
                let attributeType = attributeTypes[index];
                instance[attributeType.name] = ObjectSerializer.deserialize(data[attributeType.baseName], attributeType.type);
            }
            return instance;
        }
    }
}

export interface Authentication {
    /**
    * Apply authentication settings to header and query params.
    */
    applyToRequest(requestOptions: localVarRequest.Options): Promise<void> | void;
}

export class HttpBasicAuth implements Authentication {
    public username: string = '';
    public password: string = '';

    applyToRequest(requestOptions: localVarRequest.Options): void {
        requestOptions.auth = {
            username: this.username, password: this.password
        }
    }
}

export class HttpBearerAuth implements Authentication {
    public accessToken: string | (() => string) = '';

    applyToRequest(requestOptions: localVarRequest.Options): void {
        if (requestOptions && requestOptions.headers) {
            const accessToken = typeof this.accessToken === 'function'
                            ? this.accessToken()
                            : this.accessToken;
            requestOptions.headers["Authorization"] = "Bearer " + accessToken;
        }
    }
}

export class ApiKeyAuth implements Authentication {
    public apiKey: string = '';

    constructor(private location: string, private paramName: string) {
    }

    applyToRequest(requestOptions: localVarRequest.Options): void {
        if (this.location == "query") {
            (<any>requestOptions.qs)[this.paramName] = this.apiKey;
        } else if (this.location == "header" && requestOptions && requestOptions.headers) {
            requestOptions.headers[this.paramName] = this.apiKey;
        } else if (this.location == 'cookie' && requestOptions && requestOptions.headers) {
            if (requestOptions.headers['Cookie']) {
                requestOptions.headers['Cookie'] += '; ' + this.paramName + '=' + encodeURIComponent(this.apiKey);
            }
            else {
                requestOptions.headers['Cookie'] = this.paramName + '=' + encodeURIComponent(this.apiKey);
            }
        }
    }
}

export class OAuth implements Authentication {
    public accessToken: string = '';

    applyToRequest(requestOptions: localVarRequest.Options): void {
        if (requestOptions && requestOptions.headers) {
            requestOptions.headers["Authorization"] = "Bearer " + this.accessToken;
        }
    }
}

export class VoidAuth implements Authentication {
    public username: string = '';
    public password: string = '';

    applyToRequest(_: localVarRequest.Options): void {
        // Do nothing
    }
}

export type Interceptor = (requestOptions: localVarRequest.Options) => (Promise<void> | void);
