/**
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { RequestFile } from './models';
import { ObjectTargetResponseResource } from './objectTargetResponseResource';
import { ObjectTargetResponseWtoFile } from './objectTargetResponseWtoFile';

export class ObjectTargetResponse {
    /**
    * Unique identifier of the Target.
    */
    'id'?: string;
    /**
    * Name of the Target.
    */
    'name'?: string;
    /**
    * Type of the Target (\"Image\" for Image Targets or \"Object\" for Object Targets).
    */
    'type'?: string;
    /**
    * File size of the stored resource.
    */
    'fileSize'?: number;
    /**
    * Modification timestamp.
    */
    'modDat'?: number;
    /**
    * Creation timestamp.
    */
    'creDat'?: number;
    /**
    * Indicates if an Object Target is extendable to improve tracking and recognition quality. Only Image-based Object Targets are extendable. 
    */
    'isExpandable'?: boolean;
    /**
    * The physical (real world) size of the Target, in millimeters. Set to null to reset.
    */
    'realWorldScale'?: number;
    'resource'?: ObjectTargetResponseResource;
    /**
    * URL to the Target resource thumbnail.
    */
    'thumbnailUrl'?: string;
    'wtoFile'?: ObjectTargetResponseWtoFile;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "id",
            "baseName": "id",
            "type": "string"
        },
        {
            "name": "name",
            "baseName": "name",
            "type": "string"
        },
        {
            "name": "type",
            "baseName": "type",
            "type": "string"
        },
        {
            "name": "fileSize",
            "baseName": "fileSize",
            "type": "number"
        },
        {
            "name": "modDat",
            "baseName": "modDat",
            "type": "number"
        },
        {
            "name": "creDat",
            "baseName": "creDat",
            "type": "number"
        },
        {
            "name": "isExpandable",
            "baseName": "isExpandable",
            "type": "boolean"
        },
        {
            "name": "realWorldScale",
            "baseName": "realWorldScale",
            "type": "number"
        },
        {
            "name": "resource",
            "baseName": "resource",
            "type": "ObjectTargetResponseResource"
        },
        {
            "name": "thumbnailUrl",
            "baseName": "thumbnailUrl",
            "type": "string"
        },
        {
            "name": "wtoFile",
            "baseName": "wtoFile",
            "type": "ObjectTargetResponseWtoFile"
        }    ];

    static getAttributeTypeMap() {
        return ObjectTargetResponse.attributeTypeMap;
    }
}

